#<profile4xi profile = "11"/>
# -------------------------------------------------------------------------------------------------
#<program4xi program = "act4xi.py">
#<abstract4xi abstract = "imports all actor2*4xi.py in multiprocessing4xi and produces info about all nouns in the system"/>
#<refer4xi reference = "Studio4Xi"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
#<use4xi usage = "
#
# 1) go to Studio4Xi in commmand mode
#       > go3studio4fb <-- Python 3 version of Studio4Xi in Fastblack workstation (fb)
#       Tip: you could use the same go2studio4xi-command in all workstations just varying the content! 
#
# 3) delete all files in \c4xi\profile\developer4xi\act4xi
#
# 4) > act4xi
# nb: deletes older cluster4xi.html, super4xi.html and index2act4xi.html
#
# 5) view results
# 5a) generated HTML files in c4xi/profile/developer4xi/act4xi/
# 5b) STATISTICS in act4xi.txt
#
# 6) modify multiprocessing4xi modules, if necessary
# 6a) act2?4xi.py where ? = _,a,b,c ... z  
# 6b) noun4xi.py
# 6c) noun2cluster4xi.py
#
# 7) use colors 
# 7a) see examples such as hello_world4xi.py and the files generated by running it!
#"
#/>
# ------------------------------------------------------------------------------------------------- 


# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'act4xi' ]
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass

#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from time4xi import time4xi
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI 

from actor2a4xi import Actor2a4Xi
from actor2b4xi import Actor2b4Xi
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi

from noun4xi import ClusterKB4Xi
# ClusterKB4Xi = {
#        'a': Cluster2a4Xi, #01
#        ...
#        'z': Cluster2z4Xi, #26
#        '_': Cluster2_4Xi  #27 
#        }

from noun4xi import ClusterColor4Xi
# ClusterColor4Xi = {
#        #       NOUN 1    #SUPER #CLUSTER NUMBER                     # NOUN EXAMPLES          
#        #       BASE      INDEX     & NAME 
#        1:  {1: '#7C6142', 5: 0, 6: 'function'},                      # -functioned-by-             
# 
#        33: {1: '#E9BBBB', 5: 7, 6: 'miscellaneous'}                  # -abbreviated-by-; -commented-by-                                                                                                                                                                                                                    
#        } 

from noun4xi import SuperClusterColor4Xi
# SuperClusterColor4Xi = {
#        #   NETWORK-CENTRIC NOUNS AT REMOTE AND DEMANDING THEATERS
#        1:  {1: '#9BA2A2', 5: 'function'},      #     
#        ...
#        8:  {1: '#DE9ABC', 5: 'miscellaneous'}  #                           
#        }

from noun2cluster4xi import Noun2Cluster4Xi  
# Noun2Cluster4Xi = {
#     '-abbreviate-by-':          33,
#     ...
#     '-born:'    :                4,
#     ...
#     '-writing-by-':             33
#     ...

from noun4xi import NounKB4Xi
# NounKB4Xi = {
#        'a': Actor2a4Xi, #01
#        ...
#        'z': Actor2z4Xi, #26
#        '_': Actor2_4Xi  #27 
#        }

#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi globals                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global ActorKB4Xi 
global kb2link4url
global index2name4url
global base2link
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
base2link = VersionKB4Xi['act2studio'] 
kb2link4url = {}
index2name4url = 0

start_tag4xi = '<impose4xi'
end_tag4xi   = '</impose4xi>'
path2source    = VersionKB4Xi['multiprocessing4xi']
path2act = VersionKB4Xi['control2studio'] + "profile//developer4xi//act4xi//"
path2temp      = VersionKB4Xi['temp2studio']
linefeed = "\n"
separator2value = ";"
count2errors = 0

ActorKB4Xi = {}
ActorKB4Xi['a'] = Actor2a4Xi
ActorKB4Xi['b'] = Actor2b4Xi
ActorKB4Xi['c'] = Actor2c4Xi
ActorKB4Xi['d'] = Actor2d4Xi
ActorKB4Xi['e'] = Actor2e4Xi
ActorKB4Xi['f'] = Actor2f4Xi
ActorKB4Xi['g'] = Actor2g4Xi
ActorKB4Xi['h'] = Actor2h4Xi
ActorKB4Xi['i'] = Actor2i4Xi
ActorKB4Xi['j'] = Actor2j4Xi
ActorKB4Xi['k'] = Actor2k4Xi
ActorKB4Xi['l'] = Actor2l4Xi
ActorKB4Xi['m'] = Actor2m4Xi
ActorKB4Xi['n'] = Actor2n4Xi
ActorKB4Xi['o'] = Actor2o4Xi
ActorKB4Xi['p'] = Actor2p4Xi
ActorKB4Xi['q'] = Actor2q4Xi
ActorKB4Xi['r'] = Actor2r4Xi
ActorKB4Xi['s'] = Actor2s4Xi
ActorKB4Xi['t'] = Actor2t4Xi
ActorKB4Xi['u'] = Actor2u4Xi
ActorKB4Xi['v'] = Actor2v4Xi
ActorKB4Xi['w'] = Actor2w4Xi
ActorKB4Xi['x'] = Actor2x4Xi
ActorKB4Xi['y'] = Actor2y4Xi
ActorKB4Xi['z'] = Actor2z4Xi
ActorKB4Xi['_'] = Actor2_4Xi 

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "produce2super4xi" usage = "
#  produces super for actors   
#">                           
# -------------------------------------------------------------------------------------------------
def produce2super4xi():
    global base2link
    global kb2link4url
    global index2name4url
    
    print('=' *70)
    name2super = 'super4xi'
    path2super = path2act + name2super + '.html'    
    print("(STEP 40/70) ACT4XI: CREATING SUPER DOCUMENT ", path2super)
    # ..//..//..//..//studio4xi//c4xi//profile//developer4xi//act4xi//super4xi.html
    print('=' *70)    
    # ---------------------------------------------------------------------   
    # PRODUCE SUPER4XI.HTML
    # ---------------------------------------------------------------------     
           # SuperClusterColor4Xi = {
           # 1:  {1: '#9BA2A2', 5: 'function'},      #     
           # ...
           # 8:  {1: '#DE9ABC', 5: 'miscellaneous'}  #                           
           # }

    try:
        # -----------------------------------------------------------------
        # (STEP 41/70) SAVE LINK TO SUPER NAME INTO INDEX 
        # -----------------------------------------------------------------
        key2alpha = 's'
        print("(STEP 41A/70) KEY2ALPHA: ", key2alpha, " PATH2SUPER: ", path2super) 
        # KEY2ALPHA:  s  PATH2SUPER:  ..//..//..//..//studio4xi//c4xi//profile//developer4xi//act4xi//super4xi.html
        if kb2link4url == {}:
            kb2link4url[key2alpha] = {}
            kb2link4url[key2alpha] [name2super] = path2super
            print("(STEP 41B/70) KB2LINK4URL[", key2alpha, "][", name2super, "]: ", kb2link4url[key2alpha] [name2super])
            # kb2link4url[ s ][ super4xi ]:  ..//..//..//..//studio4xi//c4xi//profile//developer4xi//act4xi//super4xi.html
                            
        else:
            keys2alpha = kb2link4url.keys()
            if key2alpha in keys2alpha:                                     
                kb2link4url[key2alpha] [name2super] = path2super
                print("(STEP 41C/70) KB2LINK4URL[", key2alpha, "][", name2super, "]: ", kb2link4url[key2alpha] [name2super])
                # kb2link4url[ s ][ super4xi ]:  ..//..//..//..//studio4xi//c4xi//profile//developer4xi//act4xi//super4xi.html

            else:
                kb2link4url[key2alpha] = {}
                kb2link4url[key2alpha] [name2super] = path2super
                print("(STEP 41D/70) KB2LINK4URL[", key2alpha, "][", name2super, "]: ", kb2link4url[key2alpha] [name2super])
                # kb2link4url[ s ][ name2super ]:  ..//..//..//..//studio4xi//c4xi//profile//developer4xi//act4xi//super4xi.html
    except:
        print("(STEP 41Z/70) *** FAILED TO SAVE LINK TO SUPER NAME ", path2super)
        # ..//..//..//..//studio4xi//c4xi//profile//developer4xi//act4xi//super4xi.html
            
                                            
    # -----------------------------------------------------------------
    # (STEP 50A/70) OPEN SUPER HTML FILE
    # -----------------------------------------------------------------
      
    f2xi=open(path2super, 'w')    
    print("(STEP 50/70) OK: OPENED FOR WRITING PATH2SUPER: ", path2super, time4xi()) 
    # ..//..//..//..//studio4xi//c4xi//profile//developer4xi//act4xi//super4xi.html
                                    
    # -----------------------------------------------------------------
    # (STEP 50B/70) WRITE HEADERS
    # -----------------------------------------------------------------
    try:      
        f2xi.write('<!DOCTYPE HTML>' + '\n')
        f2xi.write('<html>' + '\n')
        f2xi.write('<!--------------------------------------------------------------------------------------------------------------->' + '\n')
        f2xi.write('<style type="text/css" media="all">' + '\n')
        f2xi.write('  @import "https://www.yourdragonxi.org/css/halongbay.css";' + '\n')
        f2xi.write('</style>' + '\n') 
        f2xi.write('<!--------------------------------------------------------------------------------------------------------------->' + '\n')
        f2xi.write('<body>' + '\n')
        f2xi.write('<h3>' + 'Super Info ' + '[Rel 7.21] ' + '[' + time4xi() + ']' + '</h3>' + '\n')
    except:
        print("(STEP 50ZB/70) *** FAILED TO WRITE WRITE HEADERS ", time4xi()) 
    try:    
        # -----------------------------------------------------------------
        # (STEP 50C/70) WRITE START OF TABLE
        # ----------------------------------------------------------------- 
        f2xi.write('<table>' + '\n')
        f2xi.write('<tbody>' + '\n')
        f2xi.write('<tr>' + '\n') 
        f2xi.write('<td  colspan="2"><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>' + '\n')
        f2xi.write('</td>' + '\n')
        f2xi.write('</tr>' + '\n')
                                         
    except:
        print("(STEP 50ZC/70) *** FAILED TO WRITE START OF TABLE ", time4xi()) 
            
    keys2super = SuperClusterColor4Xi.keys()
    print("(STEP 50A/70) KEYS2SUPER: ", keys2super)
    # 1 ... 8
    
    for key2super in sorted(keys2super):
        f2xi.write('<tr>' + '\n')
        f2xi.write('<td>' + '\n')
        f2xi.write('<h4>' + 'Super' + '</h4>' + '\n')
        f2xi.write('</td>' + '\n')
        f2xi.write('<td>' + '\n')
        f2xi.write('<h4>' + str(key2super) + '</h4>' + '\n')
        f2xi.write('</td>' + '\n')
        f2xi.write('</tr>' + '\n')
              
        kb2use4super = SuperClusterColor4Xi[key2super]
        print("(STEP 50B/70) KB2USESUPER: ", kb2use4super)
        # 1:  {1: '#9BA2A2', 5: 'function'}
        
        keys2use4super = kb2use4super.keys()
        print("(STEP 50C/70) KEYS2USE4SUPER: ", keys2use4super)
        # 1 ... 5 
        for key2use4super in sorted(keys2use4super):
            print("(STEP 50D/70) KEY2USE4SUPER: ", key2use4super)
            # 1                        
            if key2use4super == 1:
                # -----------------------------------------------------------------
                # (STEP 51/70) WRITE SUPER COLOR
                # -----------------------------------------------------------------
                f2xi.write('<tr>' + '\n')
                f2xi.write('<td>' + '\n')
                f2xi.write('super-color' + '\n')
                f2xi.write('</td>' + '\n')
                f2xi.write('<td bgcolor=' + str(kb2use4super[key2use4super]) + '>' + '\n')
                f2xi.write('</td>' + '\n')
                f2xi.write('</tr>' + '\n')
                # super-color: '#9BA2A2'
                #
            if key2use4super == 5:
                # -----------------------------------------------------------------
                # (STEP 52/70) WRITE SUPER NAME
                # -----------------------------------------------------------------                                        
                f2xi.write('<tr>' + '\n')
                f2xi.write('<td>' + '\n')
                f2xi.write('super' + '-name' + '\n')
                f2xi.write('</td>' + '\n')
                f2xi.write('<td>' + '\n')
                f2xi.write(kb2use4super[key2use4super] + '\n')
                f2xi.write('</td>' + '\n')
                f2xi.write('</tr>' + '\n')
                # super-name: 'theater'
             
    # ------------------------------------------------------------------
    # (STEP 57/70) WRITE REST OF SUPER
    # ------------------------------------------------------------------
    f2xi.write('<tr>' + '\n') 
    f2xi.write('<td  colspan="2"><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>' + '\n') 
    f2xi.write('</td>' + '\n') 
    f2xi.write('</tr>' + '\n') 
    f2xi.write('</tbody>' + '\n') 
    f2xi.write('</table>' + '\n') 
                 
    f2xi.write('</body>' + '\n')
    f2xi.write('</html>' + '\n')
         
    # ---------------------------------------------------------------------   
    # (STEP 58/70) CLOSE SUPER OUTPUT HTML FILE
    # ---------------------------------------------------------------------           
    print("(STEP 58A/70) OK - PRODUCED OUTPUT FILE: ", path2super)
    f2xi.close()
    print("(STEP 58B/70) OK - CLOSED PATH2ACT: ", path2super)
                

#</function4xi>  


# -------------------------------------------------------------------------------------------------
#<function4xi function = "produce2cluster4xi" usage = "
#  produces cluster for actors   
#">                           
# -------------------------------------------------------------------------------------------------
def produce2cluster4xi():
    global base2link
    global kb2link4url
    global index2name4url
    
    # ---------------------------------------------------------------------   
    # PRODUCE CLUSTER4XI.HTML
    # ---------------------------------------------------------------------     
    print('=' *70)
    name2cluster = 'cluster4xi'
    path2cluster = path2act + name2cluster + '.html'    
    print("(STEP 2/70) ACT4XI: CREATING CLUSTER DOCUMENT ", path2cluster) 
    # ..//..//..//..//studio4xi//c4xi//profile//developer4xi//act4xi//cluster4xi.html
    print('=' *70)    
    
    #  ClusterColor4Xi = {
    #             1= color      5= super, 6= name
    #        1:  {1: '#7C6142', 5: 0, 6: 'function'},                      # -functioned-by-             
    #        2:  {1: '#F55A5A', 5: 1, 6: 'method'},                        #   
    #        ...
    #       33: {1: '#E9BBBB', 5: 7, 6: 'miscellaneous'}                  # -abbreviated-by-; -commented-by-                                                                                                                                                                                                                    
    #   }   
        
    path2cluster = path2act + 'cluster4xi' + '.html'    
    
    try:
        # -----------------------------------------------------------------
        # (STEP 3/70) SAVE LINK TO CLUSTER NAME INTO INDEX 
        # -----------------------------------------------------------------
        key2alpha = 'c'
        print("(STEP 3A/70) KEY2ALPHA: ", key2alpha, " PATH2CLUSTER: ", path2cluster)
        # KEY2ALPHA:  c  PATH2CLUSTER:  ..//..//..//..//studio4xi//c4xi//profile//developer4xi//act4xi//cluster4xi.html
        if kb2link4url == {}:
            kb2link4url[key2alpha] = {}
            kb2link4url[key2alpha] [name2cluster] = path2cluster
            print("(STEP 3B/70) kb2link4url[", key2alpha, "][", name2cluster, "]: ", kb2link4url[key2alpha] [name2cluster])
            # kb2link4url[ c ][ cluster4xi ]:  ..//..//..//..//studio4xi//c4xi//profile//developer4xi//act4xi//cluster4xi.html
                            
        else:
            keys2alpha = kb2link4url.keys()
            if key2alpha in keys2alpha:                                     
                kb2link4url[key2alpha] [name2cluster] = path2cluster
                print("(STEP 3C/70) kb2link4url[", key2alpha, "][", name2cluster, "]: ", kb2link4url[key2alpha] [name2cluster])
                # kb2link4url[ c ][ cluster4xi ]:  ..//..//..//..//studio4xi//c4xi//profile//developer4xi//act4xi//cluster4xi.html

            else:
                kb2link4url[key2alpha] = {}
                kb2link4url[key2alpha] [name2cluster] = path2cluster
                print("(STEP 3D/70) kb2link4url[", key2alpha, "][", name2cluster, "]: ", kb2link4url[key2alpha] [name2cluster])
                # kb2link4url[ c ][ name2cluster ]:  ..//..//..//..//studio4xi//c4xi//profile//developer4xi//act4xi//cluster4xi.html
    except:
        print("(STEP 3Z/70) *** FAILED TO SAVE LINK TO CLUSTER NAME ", path2cluster)
        # ..//..//..//..//studio4xi//c4xi//profile//developer4xi//act4xi//cluster4xi.html
             
    # -----------------------------------------------------------------
    # STEP 30/70) OPEN CLUSTER HTML FILE
    # -----------------------------------------------------------------
    f2xi=open(path2cluster, 'w')    
    print("STEP 30A/70) OK: OPENED FOR WRITING PATH2CLUSTER: ", path2cluster) 
    # ..//..//..//..//studio4xi//c4xi//profile//developer4xi//act4xi//cluster4xi.html
    
    try:    
        # -----------------------------------------------------------------
        # STEP 31/70) WRITE HEADERS
        # -----------------------------------------------------------------         
        f2xi.write('<!DOCTYPE HTML>' + '\n')
        f2xi.write('<html>' + '\n')
        f2xi.write('<!--------------------------------------------------------------------------------------------------------------->' + '\n')
        f2xi.write('<style type="text/css" media="all">' + '\n')
        f2xi.write('  @import "https://www.yourdragonxi.org/css/halongbay.css";' + '\n')
        f2xi.write('</style>' + '\n') 
        f2xi.write('<!--------------------------------------------------------------------------------------------------------------->' + '\n')
        f2xi.write('<body>' + '\n')
        f2xi.write('<h3>' + 'Cluster Info ' + '[Rel 7.21] ' + '[' + time4xi() + ']' + '</h3>' + '\n')
                                                
    except:
        print("STEP 31Z/70) *** FAILED TO WRITE HEADERS ", time4xi()) 
         
    try:    
        # -----------------------------------------------------------------
        # STEP 32/70) WRITE START OF TABLE
        # ----------------------------------------------------------------- 
        print("STEP 32/70) STARTING TO WRITE START OF TABLE ", time4xi()) 
        f2xi.write('<table>' + '\n')
        f2xi.write('<tbody>' + '\n')
        f2xi.write('<tr>' + '\n') 
        f2xi.write('<td  colspan="2"><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>' + '\n')
        f2xi.write('</td>' + '\n')
        f2xi.write('</tr>' + '\n')
                                        
    except:
        print("STEP 32Z/70) *** FAILED TO WRITE START OF TABLE ", time4xi())         
    
        
    # -----------------------------------------------------------------
    # STEP 33/70) CLUSTERS
    # -----------------------------------------------------------------     
    # ClusterColor4Xi = {
    #        #       NOUN 1    #SUPER #CLUSTER NUMBER                     # NOUN EXAMPLES          
    #        #       BASE      INDEX     & NAME 
    #        1:  {1: '#7C6142', 5: 0, 6: 'function'},                      # -functioned-by-             
    # 
    #        33: {1: '#E9BBBB', 5: 7, 6: 'miscellaneous'}                  # -abbreviated-by-; -commented-by-                                                                                                                                                                                                                    
    #        } 
    keys2cluster = ClusterColor4Xi.keys()
    print("STEP 33A/70) KEYS2CLUSTER: ", keys2cluster)
    # dict_keys([1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33])
    
    for key2cluster in sorted(keys2cluster):
        # -----------------------------------------------------------------
        # STEP 33B/70) CLUSTER
        # -----------------------------------------------------------------    
        print("STEP 33B/70) KEYSCLUSTER: ", key2cluster)
        # 1
        f2xi.write('<tr>' + '\n') 
        f2xi.write('<td>' + '\n') 
        f2xi.write('<h4>' + 'Cluster' + '</h4>' + '\n')
        f2xi.write('</td>' + '\n')
        f2xi.write('<td>' + '\n') 
        f2xi.write('<h4>' + str(key2cluster) + '</h4>' + '\n')
        f2xi.write('</td>' + '\n')  
        f2xi.write('</tr>' + '\n')
        #
             
        kb2use4cluster = ClusterColor4Xi[key2cluster]
        print("STEP 33C/70) KB2USECLUSTER: ", kb2use4cluster)
        # {1: '#7C6142', 5: 0, 6: 'function'}
        
        keys2use4cluster = kb2use4cluster.keys()
        print("STEP 33D/70) KEYS2USE4CLUSTER: ", keys2use4cluster)
        # dict_keys([1, 5, 6])
        for key2use4cluster in sorted(keys2use4cluster):
            print("STEP 33E/70) KEY2USE4CLUSTER: ", key2use4cluster)
            # 1, 5                       
            if key2use4cluster == 1:
                # -----------------------------------------------------------------
                # (STEP 33F/70) WRITE CLUSTER COLOR
                # -----------------------------------------------------------------
                print("STEP 33F/70) KEY2USE4CLUSTER: ", key2use4cluster, " COLOR: ", str(kb2use4cluster[key2use4cluster]))
                # KEY2USE4CLUSTER:  1  COLOR:  #7C6142
                f2xi.write('<tr>' + '\n')
                f2xi.write('<td>' + '\n') 
                f2xi.write('cluster-color' + '\n')
                f2xi.write('</td>' + '\n')
                f2xi.write('<td bgcolor=' + str(kb2use4cluster[key2use4cluster]) + '>' + '\n')
                f2xi.write('</td>' + '\n')  
                f2xi.write('</tr>' + '\n')
                
                
            if key2use4cluster == 5:
                # -----------------------------------------------------------------
                # (STEP 34/70) WRITE SUPER INFO
                # -----------------------------------------------------------------                                        
                # SuperClusterColor4Xi = {
                #   1:  {1: '#9BA2A2', 5: 'function'},      #     
                #   ...
                #   8:  {1: '#DE9ABC', 5: 'miscellaneous'}  #                           
                print("STEP 34/70) STARTING TO WRITE SUPER INFO ")
                # 
                try:
                    key2link4super = int(kb2use4cluster[key2use4cluster]) + 1  # NOTE !!!!!!!
                    print("(STEP 34A/70) KEY2LINK4SUPER: ", key2link4super)
                    # 0 
                    kb2use4super = SuperClusterColor4Xi[key2link4super]
                    print("(STEP 34B/70) KB2USE4SUPER: ", kb2use4super)
                    # {1: '#9BA2A2', 5: 'function'},      #   
                    keys2use4super = kb2use4super.keys()
                    print("(STEP 34C/70) KEYS2USE4SUPER: ", keys2use4super)
                    # dict_keys([1, 5])
                except:
                    print("STEP 34Z/70) *** FAILED TO WRITE SUPER INFO ")
                
                for key2use4super in keys2use4super:
                    if key2use4super == 1:
                        try:
                            print("(STEP 33E/70) KEY2USE4SUPER: ", key2use4super)
                            # 1
                            f2xi.write('<tr>' + '\n')
                            f2xi.write('<td>' + '\n')
                            f2xi.write('super-color' + '\n')
                            f2xi.write('</td>' + '\n')
                            f2xi.write('<td bgcolor=' + str(kb2use4super[key2use4super]) + '>' + '\n')
                            f2xi.write('</td>' + '\n')
                            f2xi.write('</tr>' + '\n')
                            # '#9BA2A2'
                            
                        except:
                            print("(STEP 33Z1/70) *** FAILED IN SUPER PROCESSING, KEY2USE4SUPER: ", key2use4super, " FOR: ", path2cluster) 
                    if key2use4super == 5:
                        try:
                            print("(STEP 33F/70) KEY2USE4SUPER: ", key2use4super)
                            # 5
                            f2xi.write('<tr>' + '\n')
                            f2xi.write('<td>' + '\n')
                            f2xi.write('super-name' + '\n')
                            f2xi.write('</td>' + '\n')
                            f2xi.write('<td>' + '\n')
                            f2xi.write(str(kb2use4super[key2use4super]) + '\n')
                            f2xi.write('</td>' + '\n')
                            f2xi.write('</tr>' + '\n')
                            # super-name 'function'
                        except:
                            print("(STEP 33Z2/70) *** FAILED IN SUPER-CLUSTER PROCESSING FOR: ", path2cluster)     
                         
            if key2use4cluster == 6:
                try:
                    # {1: '#7C6142', 5: 0, 6: 'function'}
                    print("(STEP 34/70) KEY2USE4CLUSTER: ", key2use4cluster)
                    # 6
                    f2xi.write('<tr>' + '\n')
                    f2xi.write('<td>' + '\n')
                    f2xi.write('cluster-name' + '\n')
                    f2xi.write('</td>' + '\n')
                    f2xi.write('<td>' + '\n')
                    f2xi.write(str(kb2use4cluster[key2use4cluster]) + '\n')
                    f2xi.write('</td>' + '\n')
                    f2xi.write('</tr>' + '\n')
                    # cluster-name function
                except:
                    print("(STEP 34Z/70) *** FAILED - KEY2USECLUSTER: ", key2use4cluster)
                    
    # ------------------------------------------------------------------
    # (STEP 35/70) WRITE REST
    # ------------------------------------------------------------------
    print("(STEP 35/70) STARTING TO WRITE REST for CLUSTER")
    try:
        f2xi.write('<tr>' + '\n') 
        f2xi.write('<td  colspan="2"><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>' + '\n') 
        f2xi.write('</td>' + '\n') 
        f2xi.write('</tr>' + '\n') 
        f2xi.write('</tbody>' + '\n') 
        f2xi.write('</table>' + '\n') 
        
        f2xi.write('</body>' + '\n')
        f2xi.write('</html>' + '\n')
    except:
        print("(STEP 35Z/70) *** FAILED TO WRITE REST FOR CLUSTER ")
             
    # ---------------------------------------------------------------------   
    # (STEP 36/70) CLOSE OUTPUT HTML FILE
    # ---------------------------------------------------------------------           
    print("(STEP 36A/70) OK - PRODUCED CLUSTER OUTPUT FILE: ", path2cluster)
    f2xi.close()
    print("(STEP 36B/70) OK - CLOSED PATH2ACT: ", path2cluster)
        


#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "produce2actor4xi" usage = "
#  produces actors   
#">                           
# -------------------------------------------------------------------------------------------------
def produce2actor4xi():
    global ActorKB4Xi 
    global base2link
    global kb2link4url
    global index2name4url
    
       
    keys2alpha = ActorKB4Xi.keys()
    for key2alpha in sorted(keys2alpha):
        # a,b ... z    
        
        kb2use4actor = ActorKB4Xi[key2alpha]
        # Actor2a4Xi = {'ace_cache4xi':                 {1: '#50506C', 2:25},  # doer                             
        #               ...
        #               'Assets4Xi':                    {1: '#67D7D7', 2:20}
        
        keys2use4actor = kb2use4actor.keys()
        print("(STEP 13A/70) KEYS2USE4ACTOR: ", keys2use4actor) 
        # dict_keys(['_C4Xi', '_exit_function4xi', '__init__', '_new_value4xi', '_ConnectionBase4Xi' ... '_get_listener4xi', '_run_after_forkers4xi'])
        
        for key2use4actor in sorted(keys2use4actor):
            path2use = path2act + key2use4actor + '.html' 
            path2actor = path2use.lower()
            # _c4xi.html
            
            # -----------------------------------------------------------------
            # (STEP 13B/70) OPEN ACTOR HTML FILE AND WRITE START
            # -----------------------------------------------------------------
            f2xi=open(path2actor, 'w')    
            print("(STEP 13B1/70) OK: OPENED FOR WRITING PATH2ACTOR: ", path2actor) 
            # ..//..//..//..//studio4xi//c4xi//profile//developer4xi//act4xi//_c4xi.html
            
            kb2use4attributes = kb2use4actor[key2use4actor]
            # {1: '#0080FF', 2:3}
            
            f2xi.write('<!DOCTYPE HTML>' + '\n')
            f2xi.write('<html>' + '\n')
            f2xi.write('<!--------------------------------------------------------------------------------------------------------------->' + '\n')
            f2xi.write('<style type="text/css" media="all">' + '\n')
            f2xi.write('  @import "https://www.yourdragonxi.org/css/halongbay.css";' + '\n')
            f2xi.write('</style>' + '\n') 
            f2xi.write('<!--------------------------------------------------------------------------------------------------------------->' + '\n')
            f2xi.write('<body>' + '\n')
            
                    
            # -----------------------------------------------------------------
            # STEP 32/70) WRITE START OF TABLE
            # ----------------------------------------------------------------- 
            print("STEP 13B2/70) STARTING TO WRITE START OF TABLE ", time4xi()) 
            f2xi.write('<table>' + '\n')
            f2xi.write('<tbody>' + '\n')
            f2xi.write('<tr>' + '\n') 
            f2xi.write('<td  colspan="2"><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>' + '\n')
            f2xi.write('</td>' + '\n')
            f2xi.write('</tr>' + '\n')
                 
            
            # -----------------------------------------------------------------
            # (STEP 13C/70) KEY2USE4ACTOR
            # -----------------------------------------------------------------    
            print("(STEP 13C1/70) ACTOR: ", key2use4actor)
            # _C, _C4Xi
            f2xi.write('<tr>' + '\n') 
            f2xi.write('<td>' + '\n')
            f2xi.write('<h4>' + key2use4actor + '</h4>' + '\n') 
            f2xi.write('</td>' + '\n')
                       
            print("(STEP 13C2/70) COLOR: ", kb2use4attributes[1])
            # #0080FF
            
            f2xi.write('<td>' + '\n')
            f2xi.write('</td>' + '\n')  
            f2xi.write('</tr>' + '\n')
            #
            
            # ClusterColor4Xi = {
            #        #       NOUN 1    #SUPER #CLUSTER NUMBER                     # NOUN EXAMPLES          
            #        #       BASE      INDEX     & NAME 
            #        1:  {1: '#7C6142', 5: 0, 6: 'function'},                      # -functioned-by-             
            #        ...
            #        3:  {1: '#7C6142', 5: 'flow'},                                # 
            #        ... 
            #        25: {1: '#50506C', 5: 5, 6: 'doer'},                          # -do-by-;did-by-;-delivered-by-  
            #        ...
            #        33: {1: '#E9BBBB', 5: 7, 6: 'miscellaneous'}                  # -abbreviated-by-; -commented-by-                                                                                                                                                                                                                    
            #        } 
                 
            key2link4cluster = kb2use4attributes[2]
            print("(STEP 13D/70) KEY2LINK4CLUSTER: ", key2link4cluster)
            # 3
            # 
            # -----------------------------------------------------------------
            # (STEP 13F/70) WRITE CLUSTER COLOR FOR ACTOR
            # -----------------------------------------------------------------
            kb2attribute4cluster = ClusterColor4Xi[key2link4cluster]
            # 3:  {1: '#0080FF', 5: 2, 6: 'flow'},                          # -passed-to-; 
            
            print("(STEP 13F/70) KEY2LINK4CLUSTER: ", key2link4cluster, " COLOR: ", kb2attribute4cluster[1])
            #  KEY2LINK4CLUSTER:  3  COLOR:  #0080FF
            f2xi.write('<tr>' + '\n')
            f2xi.write('<td>' + '\n') 
            f2xi.write('cluster-color' + '\n')
            f2xi.write('</td>' + '\n')
            f2xi.write('<td bgcolor=' + str(kb2attribute4cluster[1]) + '>' + '\n')
            f2xi.write('</td>' + '\n')  
            f2xi.write('</tr>' + '\n')
                    
                    
            # -----------------------------------------------------------------
            # (STEP 14/70) WRITE SUPER INFO FOR ACTOR
            # -----------------------------------------------------------------                                        
            # SuperClusterColor4Xi = {
            #   1:  {1: '#9BA2A2', 5: 'function'},      #     
            #   ...
            #   8:  {1: '#DE9ABC', 5: 'miscellaneous'}  #                           
            print("(STEP 14/70) STARTING TO CREATE SUPER INFO ")
            # 
            try:
                key2link4super = int(kb2attribute4cluster[5]) + 1  # NOTE - YOU HAVE TO ADD ONE !!!!!!!
                print("(STEP 14A/70) KEY2LINK4SUPER: ", key2link4super)
                # 3 
                
                # SuperClusterColor4Xi = {
                # 1:  {1: '#9BA2A2', 5: 'function'},      #     
                #      2:  {1: '#0080FF', 5: 'method'},        #               
                #      3:  {1: '#7C6142', 5: 'flow'},          #                  
                #      4:  {1: '#9292A1', 5: 'object'},        #      
                #      5:  {1: '#0B6138', 5: 'activator'},     #                            
                #      6:  {1: '#F55A5A', 5: 'mathematician'}, #
                #      7:  {1: '#EE4545', 5: 'initializer'},   # 
                #      8:  {1: '#DE9ABC', 5: 'miscellaneous'}  #                           
                #     }
                
                
                kb2use4super = SuperClusterColor4Xi[key2link4super]
                print("(STEP 14B/70) KB2USE4SUPER: ", kb2use4super) 
                # {1: '#7C6142', 5: 'flow'} 
                keys2use4super = kb2use4super.keys()
                print("(STEP 14C/70) KEYS2USE4SUPER: ", keys2use4super)
                # dict_keys([1, 5])
            except:
                print("(STEP 14Z/70) *** FAILED TO CREATE SUPER INFO ")
                
            try:        
                for key2use4super in keys2use4super:
                    if key2use4super == 1:
                        try:
                            print("(STEP 13E/70) KEY2USE4SUPER: ", key2use4super)
                            # 1
                            f2xi.write('<tr>' + '\n')
                            f2xi.write('<td>' + '\n')
                            f2xi.write('super-color' + '\n')
                            f2xi.write('</td>' + '\n')
                            f2xi.write('<td bgcolor=' + str(kb2use4super[key2use4super]) + '>' + '\n')
                            f2xi.write('</td>' + '\n')
                            f2xi.write('</tr>' + '\n')
                            # '#9BA2A2'
                            
                        except:
                            print("(STEP 13Z1/70) *** FAILED IN SUPER PROCESSING, KEY2USE4SUPER: ", key2use4super, " FOR: ", path2cluster) 
                    if key2use4super == 5:
                        try:
                            print("(STEP 13F/70) KEY2USE4SUPER: ", key2use4super, " SUPER-NAME: ", kb2use4super[key2use4super])
                            # 5
                            f2xi.write('<tr>' + '\n')
                            f2xi.write('<td>' + '\n')
                            f2xi.write('super-name' + '\n')
                            f2xi.write('</td>' + '\n')
                            f2xi.write('<td>' + '\n')
                            f2xi.write(str(kb2use4super[key2use4super]) + '\n')
                            f2xi.write('</td>' + '\n')
                            f2xi.write('</tr>' + '\n')
                            # super-name 'function'
                        except:
                            print("(STEP 13Z2/70) *** FAILED IN SUPER-CLUSTER PROCESSING FOR: ", path2cluster)     
            except:
                print("(STEP 14Z1/70) *** FAILED TO PRODUCE SUPER INFO ")                 
                        
            # ------------------------------------------------------------------
            # (STEP 15/70) WRITE REST OF ACTOR
            # ------------------------------------------------------------------
            print("(STEP 15/70) STARTING TO WRITE REST FOR ACTOR")
            try:
                f2xi.write('<tr>' + '\n') 
                f2xi.write('<td  colspan="2"><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>' + '\n') 
                f2xi.write('</td>' + '\n') 
                f2xi.write('</tr>' + '\n') 
                f2xi.write('</tbody>' + '\n') 
                f2xi.write('</table>' + '\n') 
                
                f2xi.write('</body>' + '\n')
                f2xi.write('</html>' + '\n')
            except:
                print("(STEP 15Z/70) *** FAILED TO WRITE REST FOR ACTOR ")
                     
            # ---------------------------------------------------------------------   
            # (STEP 16/70) CLOSE OUTPUT HTML FILE
            # ---------------------------------------------------------------------           
            print("(STEP 16A/70) OK - PRODUCED ACTOR OUTPUT FILE: ", path2actor)
            # ..//..//..//..//studio4xi//c4xi//profile//developer4xi//act4xi//_c4xi.html
            f2xi.close()
            print("(STEP 16B/70) OK - CLOSED PATH2ACT: ", path2actor)
            # ..//..//..//..//studio4xi//c4xi//profile//developer4xi//act4xi//_c4xi.html
            # ...
            # ..//..//..//..//studio4xi//c4xi//profile//developer4xi//act4xi//apu2buffer4xi.html
                            
            # -----------------------------------------------------------------
            # (STEP 17/70) SAVE LINK TO INDEX2URL
            # -----------------------------------------------------------------
            key2use4actor = key2use4actor.lower()
            alpha4actor = key2use4actor[0]
            # _, a
            if kb2link4url == {}:
                # -------------------------------------------------------------
                # EMPTY KB - CREATE IT AND FIRST ALPHA DATA
                # -------------------------------------------------------------
                kb2link4url[alpha4actor] = {}
                kb2link4url[alpha4actor] [key2use4actor] = path2actor
                print("(STEP 17A/70) kb2link4url[", alpha4actor, "][", key2use4actor, "]: ", kb2link4url[alpha4actor] [key2use4actor])  
                # kb2link4url[ _ ][ _c ]:  ..//..//..//..//studio4xi//c4xi//profile//developer4xi//act4xi//_c.html
                # 
                previous2alpha = alpha4actor
                 
            else:
                # -------------------------------------------------------------
                # NON-EMPTY KB - UPDATE
                # -------------------------------------------------------------
                if previous2alpha == alpha4actor:
                    # -------------------------------------------------------------
                    # SAME ALPHA - ADD
                    # -------------------------------------------------------------   
                    kb2link4url[alpha4actor] [key2use4actor] = path2actor
                    print("(STEP 17B/70) kb2link4url[", alpha4actor, "][", key2use4actor, "]: ", kb2link4url[alpha4actor] [key2use4actor])
                    # kb2link4url[ _ ][ _c4xi ]:  ..//..//..//..//studio4xi//c4xi//profile//developer4xi//act4xi//_c4xi.html
                    # ...
                    # kb2link4url[ _ ][ _xml_loads4xi ]:  ..//..//..//..//studio4xi//c4xi//profile//developer4xi//act4xi//_xml_loads4xi.html
                    previous2alpha = alpha4actor
                else:
                    # -------------------------------------------------------------
                    # NEW ALPHA - CREATE AND ADD
                    # -------------------------------------------------------------  
                    kb2link4url[alpha4actor] = {}
                    kb2link4url[alpha4actor] [key2use4actor] = path2actor
                    print("(STEP 17C/70) kb2link4url[", alpha4actor, "][", key2use4actor, "]: ", kb2link4url[alpha4actor] [key2use4actor])
                    # kb2link4url[ a ][ace_cache4xi]:  ..//..//..//..//studio4xi//c4xi//profile//developer4xi//act4xi//ace_cache4xi.html
                    previous2alpha = alpha4actor
                    
            
#</function4xi>   

# -------------------------------------------------------------------------------------------------
#<function4xi function = "produce2index4xi" usage = "
#  produces index   
#">                           
# -------------------------------------------------------------------------------------------------
def produce2index4xi():
    global base2link
    global kb2link4url
    global index2name4url
    
    # -----------------------------------------------------------------
    # (STEP 60/70) INDEXACT4XI HTML FILE
    # -----------------------------------------------------------------
    try:
        path2index = path2act + 'index2actor4xi' + '.html'  
        
        f2xi=open(path2index, 'w')    
        print("(STEP 60/70) OK: OPENED FOR WRITING PATH2INDEX: ", path2index) 
        # ..//..//..//..//studio4xi//c4xi//profile//developer4xi//act4xi//index2actor4xi.html 
    except:
        print("(STEP 60Z1/70) *** FAILED TO OPEN FOR WRITING PATH2INDEX: ", path2index)
    try:        
        f2xi.write('<!DOCTYPE HTML>' + '\n')
        f2xi.write('<html>' + '\n')
        f2xi.write('<!--------------------------------------------------------------------------------------------------------------->' + '\n')
        f2xi.write('<style type="text/css" media="all">' + '\n')
        f2xi.write('  @import "https://www.yourdragonxi.org/css/halongbay.css";' + '\n')
        f2xi.write('</style>' + '\n') 
        f2xi.write('<!--------------------------------------------------------------------------------------------------------------->' + '\n')
        f2xi.write('<body>' + '\n')
        f2xi.write('<img id="logo4dragonxi" src="../../../../../web/images/jpg/logo4dragonxi.jpg" alt="yourDragonXi" width="240" height="120">' + '\n')
        f2xi.write('<h3>' + 'Links to Actors ' + '[Rel 7.21] ' + '[' + time4xi() + ']' + '</h3>' + '\n')
    except:
        print("(STEP 60Z2/70) *** FAILED TO WRITE HEADER ")
                
    keys2alpha = kb2link4url.keys()
    print("(STEP 60A/70) KEYS2ALPHA: ", keys2alpha) 
    # dict_keys(['c', 's'])
    
    for key2alpha in sorted(keys2alpha):
        f2xi.write('<h4>' + str(key2alpha) + '</h4>' + '\n')
    
        kb2use4link = kb2link4url[key2alpha]
        print("(STEP 60B/70) KB2USE4LINK: ", kb2use4link)
        # {0: '..//..//..//..//studio4xi//c4xi//profile//developer4xi//act4xi//cluster4xi.html'}
        # ...
        
        keys2use4link = kb2use4link.keys()
        print("(STEP 60C/70) KEYS2USE4INDEX: ", keys2use4link)
        # dict_keys([0])
        for key2use4link in sorted(keys2use4link):
            print("(STEP 60D/70) KEY2USE4LINK: ", key2use4link)
            # 0
            try:       
                print("(STEP 60E/70) BASE2LINK: ", base2link) 
                # ..//act4xi//
                
                source2use = str(kb2use4link [key2use4link])
                # AcquirerProxy4Xi
            except:
                print("(STEP 60Z1/70) *** FAILED - KEY2USE4LINK: ", key2use4link)
            
            try:        
                source2link = source2use.lower() # Linux must
                print("(STEP 60F/70) SOURCE2LINK: ", source2link)
            except:
                print("(STEP 60Z2/70) *** FAILED - KEY2USE4LINK: ", key2use4link)
            try:     
                # acquirerproxy4xi
                text2search = base2link[4:]
                print("(STEP 60G/70) TEXT2SEARCH: ", text2search)
                # act4xi//
                index2pattern = str.find(source2link,text2search)
                print("(STEP 60H/70) INDEX2PATTERN: ", index2pattern)
            except:
                print("(STEP 60Z3/70) *** FAILED - KEY2USE4LINK: ", key2use4link)
            try:               
                if index2pattern == -1:
                    print("(STEP 60Z1/70) *** ERROR SOURCE2LINK: ", source2link, " MISSING BASE2LINK: ", base2link)
                    #     
                else:
                    name2link = source2link[index2pattern+len(text2search):]            
                    print("(STEP 60I/70) NAME2LINK: ", name2link)
                    #
                    f2xi.write('<br /><b>&raquo;</b><a href="' + base2link + name2link + '" target="_blank">' + name2link + '</a>\n')  
                    # <br /><b>&raquo;</b><a href="..//act4xi//ace_cache4xi.html" target="_blank">ace_cache4xi.html</a>
            except:
                print("(STEP 60Z4/70) *** FAILED - KEY2USE4LINK: ", key2use4link)
                
    # ------------------------------------------------------------------
    # (STEP 67/70) WRITE REST FOR INDEX4ACT
    # ------------------------------------------------------------------
    print("(STEP 67/70) WRITING REST FOR INDEX4ACT ")
    f2xi.write('</body>' + '\n')
    f2xi.write('</html>' + '\n')
         
    # ---------------------------------------------------------------------   
    # (STEP 68/70) CLOSE INDEX4ACT OUTPUT HTML FILE
    # ---------------------------------------------------------------------           
    print("(STEP 68A/70) OK - PRODUCED OUTPUT FILE: ", path2index)
    try:
        f2xi.close()
        print("(STEP 68B/70) OK - CLOSED PATH2ACT: ", path2index)
    except:
        print("(STEP 68Z1/70) *** FAILED TO CLOSE INDEX4ACT HTML FILE ***")  

#</function4xi>  


    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   main function of act4xi.py
#">                           
# -------------------------------------------------------------------------------------------------
def main():
    global base2link
    global kb2link4url
    global index2name4url
    
    # ---------------------------------------------------------------------   
    # DEFINE INPUT
    # ---------------------------------------------------------------------      
    path2source  = VersionKB4Xi['multiprocessing4xi']  
    
    produce2actor4xi()
    produce2cluster4xi()
    produce2super4xi()
    produce2index4xi()
 
        

#</function4xi>    
    
        
# -------------------------------------------------------------------------------------------------
#
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()        

#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   act4xi.txt
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of act4xi.py                            
# ------------------------------------------------------------------------------------------------- 
#"
#/>
